# Armbian u-boot install script for linux-u-boot-rk322x-box-current 2024.07-S3f77-P5ac9-H43ab-V60ac-Bb703-R448a
# This file provides functions for deploying u-boot to a block device.
DIR=/usr/lib/linux-u-boot-current-rk322x-box
write_uboot_platform () 
{ 
    while [[ -n $DIR ]]; do
        [[ "$BOOT_SOC" != "rk322x" ]] && break;
        SIGNATURE_OFFSET=$(dd if=$2 bs=128k count=1 2> /dev/null | od -A o -w4 -tx4 | grep 'a7866565' | cut -d " " -f 1);
        [[ $? -ne 0 ]] && break;
        [[ -z $SIGNATURE_OFFSET ]] && break;
        CMD_RATE_OFFSET=$(($SIGNATURE_OFFSET - 16));
        CR_BYTE=$(od -A n -t dI -j $CMD_RATE_OFFSET -N 1 $2);
        [[ -z $CR_BYTE ]] && break;
        [[ "$CR_BYTE" -ne 0 && "$CR_BYTE" -ne 1 ]] && break;
        SIGNATURE_OFFSET=$(dd if=$1/u-boot-rk322x-with-spl.bin bs=128k count=1 2> /dev/null | od -A o -w4 -tx4 | grep 'a7866565' | cut -d " " -f 1);
        [[ $? -ne 0 ]] && break;
        [[ -z $SIGNATURE_OFFSET ]] && break;
        CMD_RATE_OFFSET=$(($SIGNATURE_OFFSET - 16));
        DST_BYTE=$(od -A n -t dI -j $CMD_RATE_OFFSET -N 1 $1/u-boot-rk322x-with-spl.bin);
        [[ "$DST_BYTE" -ne 0 && "$DST_BYTE" -ne 1 ]] && break;
        [[ "$CR_BYTE" -eq 0 ]] && HEX_CR="\x00";
        [[ "$CR_BYTE" -eq 1 ]] && HEX_CR="\x01";
        echo -e $HEX_CR | dd of=$1/u-boot-rk322x-with-spl.bin bs=1 seek=$CMD_RATE_OFFSET count=1 conv=notrunc > /dev/null 2>&1;
        break;
    done;
    UBOOT_SRC="u-boot-rk322x-with-spl.bin";
    dd if=/dev/zero of=$2 bs=32k count=63 seek=1 status=noxfer > /dev/null 2>&1;
    dd if=$1/$UBOOT_SRC of=$2 bs=32k seek=1 conv=notrunc
}


